/*
 * target codecs for ffmpeg
 */

#ifndef __CODECS_H__
#define __CODECS_H__

#include <X11/X.h>
#include <X11/Intrinsic.h>
//#include <X11/StringDefs.h>

#include <ffmpeg/avcodec.h>
#include <ffmpeg/avformat.h>

/* 
 * codecs used by xvidcap 
 */
enum tCodecIDs {
	CODEC_NONE,
#ifdef HAVE_LIBAVCODEC
#ifdef HAVE_LIBAVFORMAT
	CODEC_MPEG1,
	CODEC_MJPEG,
	CODEC_MPEG4,
	CODEC_MSDIV2,
	CODEC_MSDIV3,
        CODEC_FLV,
	CODEC_DV,
	CODEC_MPEG2,
	CODEC_SVQ1,
#endif //HAVE_LIBAVFPRMAT
#endif //HAVE_LIBAVCODECS
        NUMCODECS
}; 

typedef struct _xvCodec {
	char* 	name;
        char*   longname;
	int	id;
	int	ffmpeg_id;
	int	def_br;
	int	def_fps;
	char*	allowed_fps_ranges;
	char*	allowed_fps;
} xvCodec;

/*
 * audio codecs
 */
enum tAuCodecIDs {
        AU_CODEC_NONE,
#ifdef HAVE_FFMPEG_AUDIO
        AU_CODEC_MP2,
#ifdef HAVE_LIBMP3LAME
        AU_CODEC_MP3,
#endif //HAVE_LIBMP3LAME
        AU_CODEC_PCM16,
#endif //HAVE_FFMPEG_AUDIO
        NUMAUCODECS
};

typedef struct _xvAuCodec {
        char*   name;
        char*   longname;
        int     id;
        int     ffmpeg_id;
} xvAuCodec;

/*
 * file formats
 */
/*
 * capture output formats
 *
 */
enum tcap_formats {
	CAP_NONE,
	CAP_XWD,
	CAP_PNM,
#ifdef HAVE_LIBPNG        
        CAP_PNG,
	CAP_MNG,
#endif //HAVE_LIBPNG
#ifdef HAVE_LIBJPEG
        CAP_JPG,
#endif //HAVE_LIBJPEG
#ifdef WITHGT
	CAP_QTR,
#ifdef HAVE_LIBJPEG
	CAP_QTJ,
#endif //HAVE_LIBJPEG
#ifdef HAVE_LIBPNG        
        CAP_QTP,
#endif //HAVE_LIBPNG
#endif //WITHGT
#ifdef HAVE_LIBAVCODEC
#ifdef HAVE_LIBAVFORMAT
        CAP_AVI,
	CAP_DIVX,
	CAP_ASF,
	CAP_FLV,
	CAP_SWF,
        CAP_DV,
        CAP_MPG,
        CAP_SVCD,
        CAP_MOV,
#endif //HAVE_LIBAVFPRMAT
#endif //HAVE_LIBAVCODECS
	NUMCAPS
};
#define CAP_FFM CAP_AVI


typedef struct _xvFFormat {
	char* 	name;
	char*	longname;
	char*	ffmpeg_name;
	char*	extensions;
	int	def_vid_codec;
	char*	allowed_vid_codecs;
	int	def_au_codec;
	char*	allowed_au_codecs;
	int	(*init)(void);
//	void*	(*guess_format)(char*, char*, char*);
} xvFFormat;

#endif // __CODECS_H__


void xv_codecs_init();
int xv_trans_codec(int);
int xv_is_element(char *xvList, char *xvElement);
char* xv_next_element(char* list);
int xv_codec_get_target_from_filename(char *file);
int xv_codec_is_valid_fps(int fps, int codec);
int xv_num_elements (char* list);
