/*
 * control.h
 *
 * Copyright (C) 1997 Rasca Gmelch, Berlin
 * Copyright (C) 2003,04 Karl H. Beckers, Frankfurt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __CONTROL_H__
#define __CONTROL_H__

#include "app_data.h"
#include "job.h"

// the following defines the XVC interface for UIs
// they need to be implemented by any GUI anybody wants to add in the
// future. Look at xt_*.[c|h] for how to do that
Boolean XVC_PreInit( int argc, char **argv);
Boolean XVC_CreateGUI ();
Boolean XVC_CreateFrame ();
Boolean XVC_InitGUI (xvErrorListItem* errors);
int XVC_RunGUI (void);

void XVC_AddTimeout(int ms, void *);
void XVC_ChangeGUILabel(int pic_no);
void XVC_ChangeFrame(int x, int y, int width, int height, Boolean reposition_control);
void XVC_StopCapture();
void XVC_StartCapture();

Boolean XVC_ReadOptionsFile();
Boolean XVC_WriteOptionsFile();
void XVC_FrameMonitor(int measured_time);

#endif // __CONTROL_H__

